\documentclass[a4paper]{article}

\usepackage[english]{babel} 
\usepackage[utf8x]{inputenc}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{graphicx}
\usepackage[usenames,dvipsnames]{color}
\usepackage{enumitem}
\usepackage{tcolorbox}
\usepackage[top=3cm, bottom=2cm, left=4cm , right=1.5cm]{geometry}

\usepackage{tikz}
\usepackage{upquote,textcomp}

\title{\textbf{\textcolor{violet}{\helvetica{GM}}}\textcolor{gray}{\helvetica{toolbox}}:
  Quick start \\Version 1.0.1 - August, 2019}
\date{}
\author{MJ. Cros, N. Peyrard, R. Sabbadin \\ MIAT, INRA Toulouse, France}

\DeclareMathOperator*{\argmax}{arg\,max}
\DeclareMathOperator*{\arginf}{arg\,inf}
\DeclareTextFontCommand{\helvetica}{\fontfamily{phv}\selectfont}
\DeclareTextFontCommand{\courrier}{\fontfamily{pcr}\selectfont}

\setlength{\parindent}{0pt}


\begin{document}

\maketitle

This is a quick start to learn how to use GMtoolbox (see http://inra.fr/mia/T/GMtoolbox).\\
\\
For a detailed presentation of formalization and inference in a Graphical Model (GM)
with the toolbox, please refer to the user documentation of the toolbox (included in the toolbox).\\

\section{Get GMtoolbox}
 From the Project Forge Files page:\\
 \courrier{https://sourcesup.renater.fr/frs/?group\_id=3868}\\
download the file \courrier{gmtoolbox.zip}.\\
Unzip the file and go to the \courrier{gmtoolbox} directory.
On Linux system execute the following system commands: 
\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{
\begin{verbatim}
unzip gmtoolbox.zip
cd gmtoolbox
\end{verbatim}
} \end{tcolorbox}

\vspace{0.5cm}
To use the toolbox in a MATLAB session, add the \courrier{gmtoolbox} 
directory absolute paths to MATLAB search path while being in the gmtoolbox directory. 
Execute the following MATLAB commands:
\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{
\begin{verbatim}
>> GMtoolbox_path = pwd;
>> addpath( genpath( GMtoolbox_path ) )
\end{verbatim}
} \end{tcolorbox}

\vspace{0.5cm}
To access the PDF user documentation, open the file \courrier{doc/ReferenceManual.pdf} with an 
appropriate software.\\
For any question, first consult the FAQ on the GMtoolbox website:\\
\courrier{http://inra.fr/mia/T/GMtoolbox/download.html}\\
If there is no appropriate answer or if you wish to suggest a feature, add a request on the
Bugs and Feature request of the project:\\
\courrier{https://sourcesup.renater.fr/tracker/?atid=6401\&group\_id=3868\&func=browse}\\



\section{A toy DBN inference ecology problem}

We consider a very simplified ecological network, 4 species: plankton (P), zooplankton (Z),
krill (K), marine mammals (M) which population dynamic are interdependent. 
We modelize the annual population dynamic by the following Dynamic Bayesian Network (DBN).
\begin{center}
\begin{tikzpicture}
\node[draw,circle,fill=gray!50,minimum width=1.5cm] (Pt) at (0,6) {$P^t$};
\node[draw,circle,fill=gray!50,minimum width=1.5cm] (Zt) at (0,4) {$Z^t$};
\node[draw,circle,fill=gray!50,minimum width=1.5cm] (Kt) at (0,2) {$K^t$};
\node[draw,circle,fill=gray!50,minimum width=1.5cm] (Mt) at (0,0) {$M^t$};
\node[draw,circle,fill=gray!50,minimum width=1.5cm] (Pt+1) at (4,6) {$P^{t+1}$};
\node[draw,circle,fill=gray!50,minimum width=1.5cm] (Zt+1) at (4,4) {$Z^{t+1}$};
\node[draw,circle,fill=gray!50,minimum width=1.5cm] (Kt+1) at (4,2) {$K^{t+1}$};
\node[draw,circle,fill=gray!50,minimum width=1.5cm] (Mt+1) at (4,0) {$M^{t+1}$};
\draw[->,>=latex] (Pt) -- (Pt+1) ;
\draw[->,>=latex] (Zt) -- (Zt+1) ;
\draw[->,>=latex] (Kt) -- (Kt+1) ;
\draw[->,>=latex] (Mt) -- (Mt+1) ;
\draw[->,>=latex] (Pt) -- (Zt+1) ;
\draw[->,>=latex] (Zt) -- (Kt+1) ;
\draw[->,>=latex] (Kt) -- (Mt+1) ;
\draw[->,>=latex] (Mt) -- (Pt+1) ;
\end{tikzpicture}
\end{center}
	
That is the population of plankton at time t+1 ($P^{t+1}$) is related to
the population of plankton at time t ($P^t$) and the population of marine mammals ($M^t$)
through feces, death... The other relations are prey-predator ones: marine mammals eat
zooplankton that eat plankton.

The considering qualitative states are low (1), normal (2) and high (3) population.

The transition probabilities are simplified and are the same for all species.
Considering the species V depending of also of species v, the transition $p(V^{t+1}|V^t, v^t)$
is defined by the following array T.

\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{
\begin{verbatim}
T(:,:,1) = [p1 p2 p4;   % $p(V^{t+1}=1|V^t, v^t)$
            p2 p3 p4;
            p4 p4 p4];
TT(:,:,2) =  [p4 p4 p4; % $p(V^{t+1}=2|V^t, v^t)$
              p2 p1 p2;
              p4 p4 p3];
T(:,:,3) = [p4 p4 p4;   % $p(V^{t+1}=3|V^t, v^t)$
            p4 p3 p2;
            p4 p2 p1];
\end{verbatim}
} \end{tcolorbox}
That is $p(V^{t+1}=2|V^t=3, v^t=1) = T(3,1,2) = p4$.\\
For example purpose, we choose $p1 = 0.5, p2 = 0.2, p3 = 0.05, p4 = 0.01$.\\
Furthermore initial states are likely normal $p(V^0=1)= 0.25, p(V^0=2)=0.5, p(V^0=3)=0.25$ .\\

We consider 3 years (2 time steps).

Lets now represent the relations for the entire graphical model with factors graph and variables.
\begin{center}
\begin{tikzpicture}
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Pt) at (1,6) {\tiny{$P^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Zt) at (1,4) {\tiny{$Z^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Kt) at (1,2) {\tiny{$K^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Mt) at (1,0) {\tiny{$M^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Ptt) at (4,6) {\tiny{$P^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Ztt) at (4,4) {\tiny{$Z^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Ktt) at (4,2) {\tiny{$K^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Mtt) at (4,0) {\tiny{$M^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Pttt) at (7,6) {\tiny{$P^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Zttt) at (7,4) {\tiny{$Z^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Kttt) at (7,2) {\tiny{$K^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Mttt) at (7,0) {\tiny{$M^3$}};

\node[draw,rectangle,minimum width=0.2cm] (f9) at (0,6) {\tiny{f9}};
\node[draw,rectangle,minimum width=0.2cm] (f10) at (0,4) {\tiny{f10}};
\node[draw,rectangle,minimum width=0.2cm] (f11) at (0,2) {\tiny{f11}};
\node[draw,rectangle,minimum width=0.2cm] (f12) at (0,0) {\tiny{f12}};
\draw[-,>=latex] (f9) -- (Pt);
\draw[-,>=latex] (f10) -- (Zt);
\draw[-,>=latex] (f11) -- (Kt);
\draw[-,>=latex] (f12) -- (Mt);

\node[draw,rectangle,minimum width=0.2cm] (f1) at (2.5,6) {\tiny{f1}};
\node[draw,rectangle,minimum width=0.2cm] (f2) at (2.5,4) {\tiny{f2}};
\node[draw,rectangle,minimum width=0.2cm] (f3) at (2.5,2) {\tiny{f3}};
\node[draw,rectangle,minimum width=0.2cm] (f4) at (2.5,0) {\tiny{f4}};
\draw[-,>=latex] (Pt) -- (f1);\draw[-,>=latex] (Zt) -- (f1);\draw[-,>=latex] (f1) -- (Ptt);
\draw[-,>=latex] (Zt) -- (f2);\draw[-,>=latex] (Kt) -- (f2);\draw[-,>=latex] (f2) -- (Ztt);
\draw[-,>=latex] (Kt) -- (f3);\draw[-,>=latex] (Mt) -- (f3);\draw[-,>=latex] (f3) -- (Ktt);
\draw[-,>=latex] (Mt) -- (f4);\draw[-,>=latex] (Pt) -- (f4);\draw[-,>=latex] (f4) -- (Mtt);

\node[draw,rectangle,minimum width=0.2cm] (f5) at (5.5,6) {\tiny{f5}};
\node[draw,rectangle,minimum width=0.2cm] (f6) at (5.5,4) {\tiny{f6}};
\node[draw,rectangle,minimum width=0.2cm] (f7) at (5.5,2) {\tiny{f7}};
\node[draw,rectangle,minimum width=0.2cm] (f8) at (5.5,0) {\tiny{f8}};
\draw[-,>=latex] (Ptt) -- (f5);\draw[-,>=latex] (Ztt) -- (f5);\draw[-,>=latex] (f5) -- (Pttt);
\draw[-,>=latex] (Ztt) -- (f6);\draw[-,>=latex] (Ktt) -- (f6);\draw[-,>=latex] (f6) -- (Zttt);
\draw[-,>=latex] (Ktt) -- (f7);\draw[-,>=latex] (Mtt) -- (f7);;\draw[-,>=latex] (f7) -- (Kttt);
\draw[-,>=latex] (Mtt) -- (f8);\draw[-,>=latex] (Ptt) -- (f8);\draw[-,>=latex] (f8) -- (Mttt);
\end{tikzpicture}
\end{center}


\subsection{Representation of the problem}

We define the list of variables as follows: $P^1,Z^1,K^1,M^1,P^2,Z^2,K^2,M^2,P^3,Z^3,K^3,M^3$.

Here is the same model with the coding numbers in Matlab for variables and factors.
\begin{center}
\begin{tikzpicture}
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Pt) at (1,6) {\tiny{$1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Zt) at (1,4) {\tiny{$2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Kt) at (1,2) {\tiny{$3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Mt) at (1,0) {\tiny{$4$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Ptt) at (4,6) {\tiny{$5$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Ztt) at (4,4) {\tiny{$6$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Ktt) at (4,2) {\tiny{$7$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Mtt) at (4,0) {\tiny{$8$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Pttt) at (7,6) {\tiny{$9$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Zttt) at (7,4) {\tiny{$10$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Kttt) at (7,2) {\tiny{$11$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (Mttt) at (7,0) {\tiny{$12$}};

\node[draw,rectangle,minimum width=0.2cm] (f9) at (0,6) {\tiny{9}};
\node[draw,rectangle,minimum width=0.2cm] (f10) at (0,4) {\tiny{10}};
\node[draw,rectangle,minimum width=0.2cm] (f11) at (0,2) {\tiny{11}};
\node[draw,rectangle,minimum width=0.2cm] (f12) at (0,0) {\tiny{12}};
\draw[-,>=latex] (f9) -- (Pt);
\draw[-,>=latex] (f10) -- (Zt);
\draw[-,>=latex] (f11) -- (Kt);
\draw[-,>=latex] (f12) -- (Mt);

\node[draw,rectangle,minimum width=0.2cm] (f1) at (2.5,6) {\tiny{1}};
\node[draw,rectangle,minimum width=0.2cm] (f2) at (2.5,4) {\tiny{2}};
\node[draw,rectangle,minimum width=0.2cm] (f3) at (2.5,2) {\tiny{3}};
\node[draw,rectangle,minimum width=0.2cm] (f4) at (2.5,0) {\tiny{4}};
\draw[-,>=latex] (Pt) -- (f1);\draw[-,>=latex] (Zt) -- (f1);\draw[-,>=latex] (f1) -- (Ptt);
\draw[-,>=latex] (Zt) -- (f2);\draw[-,>=latex] (Kt) -- (f2);\draw[-,>=latex] (f2) -- (Ztt);
\draw[-,>=latex] (Kt) -- (f3);\draw[-,>=latex] (Mt) -- (f3);\draw[-,>=latex] (f3) -- (Ktt);
\draw[-,>=latex] (Mt) -- (f4);\draw[-,>=latex] (Pt) -- (f4);\draw[-,>=latex] (f4) -- (Mtt);

\node[draw,rectangle,minimum width=0.2cm] (f5) at (5.5,6) {\tiny{5}};
\node[draw,rectangle,minimum width=0.2cm] (f6) at (5.5,4) {\tiny{6}};
\node[draw,rectangle,minimum width=0.2cm] (f7) at (5.5,2) {\tiny{7}};
\node[draw,rectangle,minimum width=0.2cm] (f8) at (5.5,0) {\tiny{8}};
\draw[-,>=latex] (Ptt) -- (f5);\draw[-,>=latex] (Ztt) -- (f5);\draw[-,>=latex] (f5) -- (Pttt);
\draw[-,>=latex] (Ztt) -- (f6);\draw[-,>=latex] (Ktt) -- (f6);\draw[-,>=latex] (f6) -- (Zttt);
\draw[-,>=latex] (Ktt) -- (f7);\draw[-,>=latex] (Mtt) -- (f7);;\draw[-,>=latex] (f7) -- (Kttt);
\draw[-,>=latex] (Mtt) -- (f8);\draw[-,>=latex] (Ptt) -- (f8);\draw[-,>=latex] (f8) -- (Mttt);
\end{tikzpicture}
\end{center}


\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{
\begin{verbatim}
>> fg = gm_example_Ecology()
fg = 
  struct with fields:
    Name: {'P¹'  'Z¹'  'K¹'  'M¹'  'P²'  'Z²'  'K²'  'M²'  'P³'  'Z³'  'K³'  'M³'}
    Card: [3 3 3 3 3 3 3 3 3 3 3 3]
     sfg: {[1×1 struct]}
>> gm_plot_fg( fg )
\end{verbatim}
} \end{tcolorbox}
\includegraphics{IMAGES/fg_Ecology.png}

For demonstration purpose, lets check the validity of the description with the  \courrier{gm\_check\_fg} function.

\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{
\begin{verbatim}
>> [is_OK, msg] = gm_check_fg( fg )
is_OK =
     1
msg = 
    {[]}
\end{verbatim}
} \end{tcolorbox}

No error was detected !\\
\\



\subsection{Inference of beliefs}

If the function \courrier{gm\_rg\_JT} can run (for large problem memory is not sufficient),
\courrier{gm\_infer\_GBP} provides exact values for beliefs because GBP algorithm acts as Junction tree
with the generated region graph. 
\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{
\begin{verbatim}
>> rg = gm_rg_JT( fg)
rg =
  1×1 cell array
    {1×1 struct}
>> [b, stop_by] = gm_infer_GBP ( fg , rg )
b =
  1×12 cell array
  Columns 1 through 4
    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}
  Columns 5 through 8
    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}
  Columns 9 through 12
    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}
stop_by =
  1×1 cell array
    {'epsilon'}
>>  b{9}
ans =
    0.2012
    0.5778
    0.2210
\end{verbatim}
} \end{tcolorbox}
Here, \courrier{gm\_rg\_JT} has stopped with the 'epsilon' criterium that means that the algorithm
had converged. If it was not the case (stopped by 'Nmax' criterium: maximum number of iteration 
reached), it would be necessary to be sure that the
algorithm does not oscillate and rerun it with other values for default arguments (see the
second example of this QuickStart).\\

For information purpose, lets run the others available functions 
to generate region graphs. For both of them, GBP algorithm provides 
approximate values of beliefs.  
\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{
\begin{verbatim}
>> rg = gm_rg_BETHE( fg)
rg =
  1×1 cell array
    {1×1 struct}
>> [b, stop_by] = gm_infer_GBP ( fg , rg )
b =
  1×12 cell array
  Columns 1 through 4
    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}
  Columns 5 through 8
    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}
  Columns 9 through 12
    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}
stop_by =
  1×1 cell array
    {'Nmax'}
>> b{9}
ans =
    0.1516
    0.6892
    0.1592

>> rg = gm_rg_CVM( fg)
rg =
  1×1 cell array
    {1×1 struct}
>> [b, stop_by] = gm_infer_GBP ( fg , rg )
b =
  1×12 cell array
  Columns 1 through 4
    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}
  Columns 5 through 8
    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}
  Columns 9 through 12
    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}
stop_by =
  1×1 cell array
    {'epsilon'}
>> b{9}
ans =
    0.1517
    0.6892
    0.1591
\end{verbatim}
} \end{tcolorbox}

We could infer that the population of plankton at time step 3 ($t=3$), ($P³$, variable
9 of the factor graph) is quite likely still normal (state 2).\\
Note that even for this toy example, both approximations are closed but not egal to the exact values.


\subsection{Taking into account observations}

Suppose that states of population are observed at time step 2 in state low:
$P^2=1, Z^2=1, K^2=1, M^2=1$. Then, variables 5, 6, 7, 8 are observed at state 1.

\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{
\begin{verbatim}
>> evidence=zeros(1,length(fg.Card));
>> evidence([5 6 7 8])=1; % observation of states at the 2nd time step
>> fge = gm_include_evidence(fg, evidence)
fge = 
  struct with fields:
        Name: {1×12 cell}
        Card: [3 3 3 3 3 3 3 3 3 3 3 3]
         sfg: {1×5 cell}
    evidence: [0 0 0 0 1 1 1 1 0 0 0 0]
>> gm_plot_fg( fge )
\end{verbatim}
} \end{tcolorbox}
\includegraphics[scale=0.9]{IMAGES/fge_Ecology_evi1.png}

Taking into account these observations, the initial sub factor graph is splitted in 5
sub factor graphs.

\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{
\begin{verbatim}
>> rge = gm_rg_JT( fge);
>> [b, stop_by] = gm_infer_GBP ( fge , rge );
b =
  1×12 cell array
  Columns 1 through 5
    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}
  Columns 6 through 10
    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}    {3×1 double}
  Columns 11 through 12
    {3×1 double}    {3×1 double}
stop_by =
  1×5 cell array
    {'epsilon'}    {'epsilon'}    {'epsilon'}    {'epsilon'}    {'epsilon'}
>> b{9}
ans =
    0.9615
    0.0192
    0.0192
\end{verbatim}
} \end{tcolorbox}
Now, we could infer that the population of plankton at time step 3 ($t=3$), ($P³$, variable
9 of the factor graph) is nearly for sure low (state 1).\\

The others ways of building region graph here provide the same values for beliefs.


\section{A toy Coupled HMM epidemics problem}
A Hidden Markov Model (HMM) is a Markov model in which the system being modeled
is assumed to be a Markov process with unobserved ({\it i.e.} hidden) states.
Coupled HMM (CHMM) provide interaction in state-space instead of observation
states as used in classical HMM that fails to model correlation between
inter-modal dependencies. \\
\\
Here, a Coupled HMM is used to model the dynamics of a pest that can spread on
a landscape composed of $N$ crop fields organized in a regular grid.
The neighborhood of field $i$, denoted $N_i$, is the set of the 4 closest
fields (or 3 or 2, on the borders and corners of the grid).\\

$H_t^i \in \{0,1\}$ ($1 \leq i \leq N, \ 0 \leq t \leq T$) is the state of crop field $i$ at time $t$. 
State 0  (resp. 1) represents the absence (resp. presence) of the pest in the field.
Variable  $H_t^i$ depends on  $H_{t-1}^i$ and of the  $H_{t-1}^j$ such that $j$ is in $N_i$.
The conditional probabilities of survival and apparition of the pest
in field $i$ are parameterized by 3 parameters:
\begin{itemize}
 \item $\epsilon$, the probability  of contamination from outside the landscape (long-distance dispersal).
 \item $\rho$, the probability that the pest spreads from an infected field $j \in N_i$ ($H_t^j = 1$)
   to  field $i$ between time $t$ and $t+1$. 
 \item $\nu$, the probability that an infected field at time $t $ remains infected at $t+1$
\end{itemize}
 We assume that contamination events from every neighbor fields are independent.
 Then, if ${I_t^i}$ is the number of infected neighbors of field $i$
 at time $t$ ($I_t^i = \sum_{j \in N_i} H_t^j$), we have
$$
P(H_{t+1}^i = 1 \mid H_t^i = 0, H_t^{j}, j \in N_i) = \epsilon + (1 - \epsilon)(1 - (1- \rho)^{I_t^i} )
$$
and
$$
P(H_{t+1}^i = 1 \mid H_t^i = 1, H_t^{j}, j \in N_i) =  \nu + (1 - \nu) \left(  \epsilon + (1 - \epsilon)(1 - (1- \rho)^{I_t^i} ) \right).
$$

The $H_t^i$ are hidden variables. 
During monitoring, a binary variable $O_t^n$ is observed: it takes value 1
if the pest has been observed and 0 otherwise. 
But error of detection is possible: we can have false negative observations
(the pest is there but difficult to see so it was missed)
or false positive observations (the pest was mixed up  with another one).
We define $P(O_t^i = 1 \mid X_t^i = 0) = f_p$ and   $P(O_t^i = 0 \mid X_t^i = 1) = f_n$.

``Expert'' values for the  dynamics parameters in the case of a weed species can be
 $\epsilon = 0.15, \rho = 0.2, \nu = 0.5$.
For the observations distributions, we take $f_p = 0.05$ and $f_n = 0.1$.\\
\\
We consider a square grid of N=4 fields evolving during T=2 periods.

Lets detail the problem. Here is the set of fields and the possible propagation
of pest between them.
\begin{center}
\begin{tikzpicture}
\node[draw,circle,fill=gray!50,minimum width=1cm] (3) at (0,0) {3};
\node[draw,circle,fill=gray!50,minimum width=1cm] (4) at (2,0) {4};
\node[draw,circle,fill=gray!50,minimum width=1cm] (1) at (0,2) {1};
\node[draw,circle,fill=gray!50,minimum width=1cm] (2) at (2,2) {2};
\draw[<->,>=latex] (1) -- (2) ;
\draw[<->,>=latex] (1) -- (3) ;
\draw[<->,>=latex] (2) -- (4) ;
\draw[<->,>=latex] (3) -- (4) ;
\end{tikzpicture}
\end{center}


Lets now represent state and observation variables relations between 2 time steps.
\begin{center}
\begin{tikzpicture}
\node[draw,circle, minimum width=1cm] (H1t) at (1,6) {\tiny{$H_1^t$}};
\node[draw,circle, minimum width=1cm] (H2t) at (1,4) {\tiny{$H_2^t$}};
\node[draw,circle, minimum width=1cm] (H3t) at (1,2) {\tiny{$H_3^t$}};
\node[draw,circle, minimum width=1cm] (H4t) at (1,0) {\tiny{$H_4^t$}};
\node[draw,circle, minimum width=1cm] (H1tt) at (4,6) {\tiny{$H_1^{t+1}$}};
\node[draw,circle, minimum width=1cm] (H2tt) at (4,4) {\tiny{$H_2^{t+1}$}};
\node[draw,circle, minimum width=1cm] (H3tt) at (4,2) {\tiny{$H_3^{t+1}$}};
\node[draw,circle, minimum width=1cm] (H4tt) at (4,0) {\tiny{$H_4^{t+1}$}};
\node[draw,circle, minimum width=1cm] (O1t) at (0,7) {\tiny{$O_1^t$}};
\node[draw,circle, minimum width=1cm] (O2t) at (0,5) {\tiny{$O_2^t$}};
\node[draw,circle, minimum width=1cm] (O3t) at (0,3) {\tiny{$O_3^t$}};
\node[draw,circle, minimum width=1cm] (O4t) at (0,1) {\tiny{$O_4^t$}};
\node[draw,circle, minimum width=1cm] (O1tt) at (5,7) {\tiny{$O_1^{t+1}$}};
\node[draw,circle, minimum width=1cm] (O2tt) at (5,5) {\tiny{$O_2^{t+1}$}};
\node[draw,circle, minimum width=1cm] (O3tt) at (5,3) {\tiny{$O_3^{t+1}$}};
\node[draw,circle, minimum width=1cm] (O4tt) at (5,1) {\tiny{$O_4^{t+1}$}};

\draw[->,>=latex] (H1t) -- (O1t) ;
\draw[->,>=latex] (H2t) -- (O2t) ;
\draw[->,>=latex] (H3t) -- (O3t) ;
\draw[->,>=latex] (H4t) -- (O4t) ;
\draw[->,>=latex] (H1tt) -- (O1tt) ;
\draw[->,>=latex] (H2tt) -- (O2tt) ;
\draw[->,>=latex] (H3tt) -- (O3tt) ;
\draw[->,>=latex] (H4tt) -- (O4tt) ;
\draw[->,>=latex] (H1t) -- (O1t) ;
\draw[->,>=latex] (H1t) -- (H1tt);
\draw[->,>=latex] (H2t) -- (H1tt);
\draw[->,>=latex] (H3t) -- (H1tt);
\draw[->,>=latex] (H2t) -- (H2tt);
\draw[->,>=latex] (H1t) -- (H2tt);
\draw[->,>=latex] (H4t) -- (H2tt);
\draw[->,>=latex] (H3t) -- (H3tt);
\draw[->,>=latex] (H1t) -- (H3tt);
\draw[->,>=latex] (H4t) -- (H3tt);
\draw[->,>=latex] (H4t) -- (H4tt);
\draw[->,>=latex] (H2t) -- (H4tt);
\draw[->,>=latex] (H3t) -- (H4tt);
\end{tikzpicture}
\end{center}

Lets represent now all the relations with factors graph and variables for the entire graphical model.
\begin{center}
\begin{tikzpicture}
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H1t) at (1,6) {\tiny{$H_1^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H2t) at (1,4) {\tiny{$H_2^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H3t) at (1,2) {\tiny{$H_3^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H4t) at (1,0) {\tiny{$H_4^1$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H1tt) at (4,6) {\tiny{$H_1^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H2tt) at (4,4) {\tiny{$H_2^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H3tt) at (4,2) {\tiny{$H_3^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H4tt) at (4,0) {\tiny{$H_4^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H1ttt) at (7,6) {\tiny{$H_1^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H2ttt) at (7,4) {\tiny{$H_2^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H3ttt) at (7,2) {\tiny{$H_3^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H4ttt) at (7,0) {\tiny{$H_4^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O1tt) at (3,7) {\tiny{$O_1^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O2tt) at (3,5) {\tiny{$O_2^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O3tt) at (3,3) {\tiny{$O_3^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O4tt) at (3,1) {\tiny{$O_4^2$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O1ttt) at (6,7) {\tiny{$O_1^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O2ttt) at (6,5) {\tiny{$O_2^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O3ttt) at (6,3) {\tiny{$O_3^3$}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O4ttt) at (6,1) {\tiny{$O_4^3$}};

\node[draw,rectangle,minimum width=0.2cm] (f1) at (0,6) {\tiny{f9}};
\node[draw,rectangle,minimum width=0.2cm] (f2) at (0,4) {\tiny{f10}};
\node[draw,rectangle,minimum width=0.2cm] (f3) at (0,2) {\tiny{f11}};
\node[draw,rectangle,minimum width=0.2cm] (f4) at (0,0) {\tiny{f12}};
\draw[-,>=latex] (f1) -- (H1t);
\draw[-,>=latex] (f2) -- (H2t);
\draw[-,>=latex] (f3) -- (H3t);
\draw[-,>=latex] (f4) -- (H4t);

\node[draw,rectangle,minimum width=0.2cm] (f5) at (2.5,6) {\tiny{f1}};
\node[draw,rectangle,minimum width=0.2cm] (f6) at (2.5,4) {\tiny{f2}};
\node[draw,rectangle,minimum width=0.2cm] (f7) at (2.5,2) {\tiny{f3}};
\node[draw,rectangle,minimum width=0.2cm] (f8) at (2.5,0) {\tiny{f4}};
\draw[-,>=latex] (H1t) -- (f5);\draw[-,>=latex] (H2t) -- (f5);\draw[-,>=latex] (H3t) -- (f5);\draw[-,>=latex] (f5) -- (H1tt);
\draw[-,>=latex] (H2t) -- (f6);\draw[-,>=latex] (H1t) -- (f6);\draw[-,>=latex] (H4t) -- (f6);\draw[-,>=latex] (f6) -- (H2tt);
\draw[-,>=latex] (H3t) -- (f7);\draw[-,>=latex] (H1t) -- (f7);\draw[-,>=latex] (H4t) -- (f7);\draw[-,>=latex] (f7) -- (H3tt);
\draw[-,>=latex] (H4t) -- (f8);\draw[-,>=latex] (H2t) -- (f8);\draw[-,>=latex] (H3t) -- (f8);\draw[-,>=latex] (f8) -- (H4tt);

\node[draw,rectangle,minimum width=0.2cm] (f9) at (5.5,6) {\tiny{f5}};
\node[draw,rectangle,minimum width=0.2cm] (f10) at (5.5,4) {\tiny{f6}};
\node[draw,rectangle,minimum width=0.2cm] (f11) at (5.5,2) {\tiny{f7}};
\node[draw,rectangle,minimum width=0.2cm] (f12) at (5.5,0) {\tiny{f8}};
\draw[-,>=latex] (H1tt) -- (f9);\draw[-,>=latex] (H2tt) -- (f9);\draw[-,>=latex] (H3tt) -- (f9);\draw[-,>=latex] (f9) -- (H1ttt);
\draw[-,>=latex] (H2tt) -- (f10);\draw[-,>=latex] (H1tt) -- (f10);\draw[-,>=latex] (H4tt) -- (f10);\draw[-,>=latex] (f10) -- (H2ttt);
\draw[-,>=latex] (H3tt) -- (f11);\draw[-,>=latex] (H1tt) -- (f11);\draw[-,>=latex] (H4tt) -- (f11);\draw[-,>=latex] (f11) -- (H3ttt);
\draw[-,>=latex] (H4tt) -- (f12);\draw[-,>=latex] (H2tt) -- (f12);\draw[-,>=latex] (H3tt) -- (f12);\draw[-,>=latex] (f12) -- (H4ttt);

\node[draw,rectangle,minimum width=0.2cm] (f13) at (3.5,6.5) {\tiny{f13}};
\node[draw,rectangle,minimum width=0.2cm] (f14) at (3.5,4.5) {\tiny{f14}};
\node[draw,rectangle,minimum width=0.2cm] (f15) at (3.5,2.5) {\tiny{f15}};
\node[draw,rectangle,minimum width=0.2cm] (f16) at (3.5,0.5) {\tiny{f16}};
\node[draw,rectangle,minimum width=0.2cm] (f17) at (6.5,6.5) {\tiny{f17}};
\node[draw,rectangle,minimum width=0.2cm] (f18) at (6.5,4.5) {\tiny{f18}};
\node[draw,rectangle,minimum width=0.2cm] (f19) at (6.5,2.5) {\tiny{f19}};
\node[draw,rectangle,minimum width=0.2cm] (f20) at (6.5,0.5) {\tiny{f20}};
\draw[-,>=latex] (O1tt) -- (f13);\draw[-,>=latex] (H1tt) -- (f13);
\draw[-,>=latex] (O2tt) -- (f14);\draw[-,>=latex] (H2tt) -- (f14);
\draw[-,>=latex] (O3tt) -- (f15);\draw[-,>=latex] (H3tt) -- (f15);
\draw[-,>=latex] (O4tt) -- (f16);\draw[-,>=latex] (H4tt) -- (f16);
\draw[-,>=latex] (O1ttt) -- (f17);\draw[-,>=latex] (H1ttt) -- (f17);
\draw[-,>=latex] (O2ttt) -- (f18);\draw[-,>=latex] (H2ttt) -- (f18);
\draw[-,>=latex] (O3ttt) -- (f19);\draw[-,>=latex] (H3ttt) -- (f19);
\draw[-,>=latex] (O4ttt) -- (f20);\draw[-,>=latex] (H4ttt) -- (f20);
\end{tikzpicture}
\end{center}


\subsection{Representation of the problem}


We define the list of variables as follows : \\
$H_1^1,H_2^1,H_3^1,H_4^1,H_1^2,H_2^2,H_3^2,H_4^2,H_1^3,H_2^3,H_3^3,H_4^3,O_1^2,O_2^2,O_3^2,O_4^2,O_1^3,O_2^3,O_3^3,O_4^3$ \\
and we label them $1, \cdots ,20$. That is, state variables are coded  $1, \cdots ,12$ and
observation variables are coded  $13, \cdots ,20$. \\


Here is the model with the coding numbers in Matlab for variables and factors.

\begin{center}
\begin{tikzpicture}
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H1t) at (1,6) {\tiny{1}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H2t) at (1,4) {\tiny{2}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H3t) at (1,2) {\tiny{3}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H4t) at (1,0) {\tiny{4}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H1tt) at (4,6) {\tiny{5}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H2tt) at (4,4) {\tiny{6}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H3tt) at (4,2) {\tiny{7}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H4tt) at (4,0) {\tiny{8}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H1ttt) at (7,6) {\tiny{9}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H2ttt) at (7,4) {\tiny{10}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H3ttt) at (7,2) {\tiny{11}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (H4ttt) at (7,0) {\tiny{12}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O1tt) at (3,7) {\tiny{13}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O2tt) at (3,5) {\tiny{14}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O3tt) at (3,3) {\tiny{15}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O4tt) at (3,1) {\tiny{16}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O1ttt) at (6,7) {\tiny{17}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O2ttt) at (6,5) {\tiny{18}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O3ttt) at (6,3) {\tiny{19}};
\node[draw,fill=gray!30,circle, minimum width=0.3cm] (O4ttt) at (6,1) {\tiny{20}};

\node[draw,rectangle,minimum width=0.2cm] (f1) at (0,6) {\tiny{9}};
\node[draw,rectangle,minimum width=0.2cm] (f2) at (0,4) {\tiny{10}};
\node[draw,rectangle,minimum width=0.2cm] (f3) at (0,2) {\tiny{11}};
\node[draw,rectangle,minimum width=0.2cm] (f4) at (0,0) {\tiny{12}};
\draw[-,>=latex] (f1) -- (H1t);
\draw[-,>=latex] (f2) -- (H2t);
\draw[-,>=latex] (f3) -- (H3t);
\draw[-,>=latex] (f4) -- (H4t);

\node[draw,rectangle,minimum width=0.2cm] (f5) at (2.5,6) {\tiny{1}};
\node[draw,rectangle,minimum width=0.2cm] (f6) at (2.5,4) {\tiny{2}};
\node[draw,rectangle,minimum width=0.2cm] (f7) at (2.5,2) {\tiny{3}};
\node[draw,rectangle,minimum width=0.2cm] (f8) at (2.5,0) {\tiny{4}};
\draw[-,>=latex] (H1t) -- (f5);\draw[-,>=latex] (H2t) -- (f5);\draw[-,>=latex] (H3t) -- (f5);\draw[-,>=latex] (f5) -- (H1tt);
\draw[-,>=latex] (H2t) -- (f6);\draw[-,>=latex] (H1t) -- (f6);\draw[-,>=latex] (H4t) -- (f6);\draw[-,>=latex] (f6) -- (H2tt);
\draw[-,>=latex] (H3t) -- (f7);\draw[-,>=latex] (H1t) -- (f7);\draw[-,>=latex] (H4t) -- (f7);\draw[-,>=latex] (f7) -- (H3tt);
\draw[-,>=latex] (H4t) -- (f8);\draw[-,>=latex] (H2t) -- (f8);\draw[-,>=latex] (H3t) -- (f8);\draw[-,>=latex] (f8) -- (H4tt);

\node[draw,rectangle,minimum width=0.2cm] (f9) at (5.5,6) {\tiny{5}};
\node[draw,rectangle,minimum width=0.2cm] (f10) at (5.5,4) {\tiny{6}};
\node[draw,rectangle,minimum width=0.2cm] (f11) at (5.5,2) {\tiny{7}};
\node[draw,rectangle,minimum width=0.2cm] (f12) at (5.5,0) {\tiny{8}};
\draw[-,>=latex] (H1tt) -- (f9);\draw[-,>=latex] (H2tt) -- (f9);\draw[-,>=latex] (H3tt) -- (f9);\draw[-,>=latex] (f9) -- (H1ttt);
\draw[-,>=latex] (H2tt) -- (f10);\draw[-,>=latex] (H1tt) -- (f10);\draw[-,>=latex] (H4tt) -- (f10);\draw[-,>=latex] (f10) -- (H2ttt);
\draw[-,>=latex] (H3tt) -- (f11);\draw[-,>=latex] (H1tt) -- (f11);\draw[-,>=latex] (H4tt) -- (f11);\draw[-,>=latex] (f11) -- (H3ttt);
\draw[-,>=latex] (H4tt) -- (f12);\draw[-,>=latex] (H2tt) -- (f12);\draw[-,>=latex] (H3tt) -- (f12);\draw[-,>=latex] (f12) -- (H4ttt);

\node[draw,rectangle,minimum width=0.2cm] (f13) at (3.5,6.5) {\tiny{13}};
\node[draw,rectangle,minimum width=0.2cm] (f14) at (3.5,4.5) {\tiny{14}};
\node[draw,rectangle,minimum width=0.2cm] (f15) at (3.5,2.5) {\tiny{15}};
\node[draw,rectangle,minimum width=0.2cm] (f16) at (3.5,0.5) {\tiny{16}};
\node[draw,rectangle,minimum width=0.2cm] (f17) at (6.5,6.5) {\tiny{17}};
\node[draw,rectangle,minimum width=0.2cm] (f18) at (6.5,4.5) {\tiny{18}};
\node[draw,rectangle,minimum width=0.2cm] (f19) at (6.5,2.5) {\tiny{19}};
\node[draw,rectangle,minimum width=0.2cm] (f20) at (6.5,0.5) {\tiny{20}};
\draw[-,>=latex] (O1tt) -- (f13);\draw[-,>=latex] (H1tt) -- (f13);
\draw[-,>=latex] (O2tt) -- (f14);\draw[-,>=latex] (H2tt) -- (f14);
\draw[-,>=latex] (O3tt) -- (f15);\draw[-,>=latex] (H3tt) -- (f15);
\draw[-,>=latex] (O4tt) -- (f16);\draw[-,>=latex] (H4tt) -- (f16);
\draw[-,>=latex] (O1ttt) -- (f17);\draw[-,>=latex] (H1ttt) -- (f17);
\draw[-,>=latex] (O2ttt) -- (f18);\draw[-,>=latex] (H2ttt) -- (f18);
\draw[-,>=latex] (O3ttt) -- (f19);\draw[-,>=latex] (H3ttt) -- (f19);
\draw[-,>=latex] (O4ttt) -- (f20);\draw[-,>=latex] (H4ttt) -- (f20);
\end{tikzpicture}
\end{center}


\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{
\begin{verbatim}
>> N=4; % 4 fields
>> T=2; % 2 time steps
>> Name = {'H1¹','H2¹','H3¹','H4¹', ...
           'H1²','H2²','H3²','H4²', ...
           'H1³','H2³','H3³','H4³', ...
           'O1²','O2²','O3²','O4²', ...
           'O1³','O2³','O3³','O4³'};
\end{verbatim}
} \end{tcolorbox}
\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{
\begin{verbatim}
>> fg = gm_example_CHMM(N, T);
>> fg.Name = Name
fg = 
  struct with fields:
    Card: [2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2]
     sfg: {[1×1 struct]}
    Name: {1×20 cell}
\end{verbatim}
} \end{tcolorbox}


Each variable has 2 states: 1: infected, 2: non infected.\\
The list of cardinalities of variables is defined in the Card attribut.

\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{ 
\begin{verbatim}
>> fg.Card
ans =
  Columns 1 through 20
     2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2
\end{verbatim} 
} \end{tcolorbox}

We suppose that the initial states of fields are unknown.  $P(H_i^1=1)=0.5$ with $i=\{1, 2, 3, 4\}$ \\
We then represent this \emph{a priori} knowledge on initial states with factors f9, f10, f11, f12.
For example, considering factor f1, the set of associated variable is ${H_1^1}$ coded 1
and the table is \\ $P(H_i^1=1)=0.5, P(H_i^1=2)=0.5$.

\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{ 
\begin{verbatim}
>> fg.sfg{1}.F{9}
ans =
    V: 1
    T: [2x1 double]
>> fg.sfg{1}.F{9}.T
ans =
    0.5
    0.5
\end{verbatim} 
} \end{tcolorbox}

We now define factors involved in time transitions: $f1, \cdots ,f12$. Considering factor f1,
the implied variables are $H_1^1, H_2^1,H_3^1, H_1^2$ which are labeled 1, 2, 3, 5.\\
The associated table gives $P(H_1^2 | H_1^1, H_2^1,H_3^1)$

\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{ 
\begin{verbatim}
>> fg.sfg{1}.F{1}.V
ans =
    1     2     3     5
>> fg.sfg{1}.F{5}.T
ans(:,:,1,1) =
    0.8500    0.6800
    0.5750    0.6600
ans(:,:,2,1) =
    0.6800    0.5440
    0.6600    0.7280
ans(:,:,1,2) =
    0.1500    0.3200
    0.4250    0.3400
ans(:,:,2,2) =
    0.3200    0.4560
    0.3400    0.2720
\end{verbatim} 
} \end{tcolorbox}
Then $P(H_1^2 =2| H_1^1=1, H_2^1=1,H_3^1=1)$ is coded in T(1,1,1,2) as 0.15.\\
\\
Finally, we define factors involving observation variables.
Considering factor f13, it involves 2 variables $O_1^2$ and $H_1^2$ coded 5 and 13.
We know that $P(H_1^2=1 | O_1^2=2) = fn$ and \\ $P(H_1^2=2 | O_1^2=1) = fp$. This allows 
to define the associated table.

\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{ 
\begin{verbatim}
>> fg.sfg{1}.F{13}.V
    5    13
>> fg.sfg{1}.F{13}.T
ans =
    0.9000    0.1000
    0.0500    0.9500
\end{verbatim} 
} \end{tcolorbox}

It is possible to plot the factor graph.
\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{ 
\begin{verbatim}
gm_plot_fg(fg)
\end{verbatim} 
} \end{tcolorbox}
\includegraphics[scale=0.80]{IMAGES/fg_CHMM42_auto.png}

Other layouts are possible but not really better for this problem.
\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{ 
\begin{verbatim}
gm_plot_fg(fg, 1, 'circle')
\end{verbatim} 
} \end{tcolorbox}
\includegraphics[scale=0.80]{IMAGES/fg_CHMM42.png}

\subsection{Inference of beliefs}
If we want to know the probability of field 1 to be infected at time 3, we just have to infer it.\\
Before calling Generalized Belief Propagation (GBP), the fist step is to build a region graph needed by GBP.
The toolbox proposes 3 functions. If the problem is simple use \courrier{gm\_rg\_JT, GBP} that will act as the Junction Tree
algorithm, giving the exact probability. If not applicable, try\courrier{ gm\_rg\_BETHE}.
In this last case, GBP will act as Loopy Belief Propagation.
Finally try \courrier{gm\_rg\_CVM} that will compute an approximate probability. \\
\\
In each case, check that GBP was stopped by the 'epsilon' condition,
not by 'Nmax' (the maximum number of iteration was reached).
If it is the case, play with otional arguments of GBP function as in
the next paragraph.


\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{ 
\begin{verbatim}
>> rg = gm_rg_JT(fg);
>> [b, stop_by] = gm_infer_GBP ( fg , rg );
>> stop_by
stop_by =
  1×1 cell array
    {'epsilon'} 
>> b{9}(1)
ans =
    0.7062

>> rg = gm_rg_BETHE(fg);
>> [b, stop_by] = gm_infer_GBP ( fg , rg );
>> stop_by
stop_by =
  1×1 cell array
    {'epsilon'}
>>  b{9}(1)
ans =
    0.7050

>> rg = gm_rg_CVM( fg ); 
>> [b, stop_by] = gm_infer_GBP ( fg , rg );
>>  stop_by
stop_by =
  1×1 cell array
    {'epsilon'}
>>  b{9}(1)
ans =
    0.7050
\end{verbatim} 
} \end{tcolorbox}    

The probability of field 1 at time 3 (variable $H_1^3$ coded 9) to be
infected (coded 1) is computed with \courrier{gm\_rg\_JT}) to 0.7062.
This probability is estimated to 0.7050 using \courrier{gm\_rg\_BETHE} or
\courrier{gm\_rg\_CVM}.


\subsection{Taking observations into account}

If we only observe fields at time t=3, with just field 1 infected : $O_1^3=1, O_2^3=2, O_3^3=2, O_4^3=2$.
The considered variables are coded 17, 18, 19, 20.\\
\\
We just have to enter this evidence in the factor graph and infer probabilities on the new factor graph.


\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{ 
\begin{verbatim}   
>> evidence = zeros(1, length(fg.Card));
>> evidence(17:20)=[1 2 2 2];

>> fge = gm_include_evidence(fg, evidence)
fge = 
  struct with fields:

        Card: [2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2]
         sfg: {[1×1 struct]}
        Name: {1x20 cell}
    evidence: [0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 2 2 2]

>> rge = gm_rg_JT(fge);
>> [be, stop_by] = gm_infer_GBP ( fge , rge );
>> stop_by
stop_by = 
  1×1 cell array
    {'epsilon'}
>>  be{1}(1)
ans =
    0.4924
\end{verbatim} 
} \end{tcolorbox} 

The probability of field 1 at time 1 (variable $H_1^1$ coded 1) to be
infected (coded 1) is computed with \courrier{gm\_rg\_JT}) to 0.4924.\\
For example purpose, lets approximate this probability with
\courrier{gm\_rg\_BETHE} and \courrier{gm\_rg\_CVM}.

\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{ 
\begin{verbatim}   
>> rge = gm_rg_BETHE(fge);
>> [be, stop_by] = gm_infer_GBP ( fge , rge );
>> stop_by
stop_by = 
  1×1 cell array
    {'epsilon'}
>>  be{1}(1)
ans =
    0.4947

>> rge = gm_rg_CVM(fge);
>> [be, stop_by] = gm_infer_GBP ( fge , rge );
>> stop_by
stop_by = 
  1×1 cell array
    {'Nmax'}
\end{verbatim} 
} \end{tcolorbox} 

The probability is well estimated using \courrier{gm\_rg\_BETHE} but
using \courrier{gm\_rg\_CVM} the inference algorithm is stopped by the
'Nmax' criterium (maximum number of iteration reached, by default set
to 100).\\
In this case, it is worth to evaluate the evolution of the estimation of
probabilities at each iteration. For example, lets look the evolution
for the probability of field 1 at time 1 (variable $H_1^1$ coded 1) to be
infected (coded 1) for iteration from 1 to 100.

\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{ 
\begin{verbatim}   
% We plot belief evolution
>> bt = gm_plot_belief_evolution ( 1, 1, 1, 100, fge, rge, 0.0001, 0.0 )
\end{verbatim} 
} \end{tcolorbox} 
\includegraphics[scale=0.80]{IMAGES/oscil100_CHMM42_evi1222_17-20.png}

The estimation of the probability clearly oscillates. So lets try to
use damping, that is make a compromize at each iteration between old and new values
of messages. There is still oscillation with damp at 0.1, so we try damp at 0.2.
\begin{tcolorbox}[notitle,boxrule=0pt,colback=gray!20,colframe=blue!20] \small{ 
\begin{verbatim}   
[be, stop_by] = gm_infer_GBP ( fge , rge, 100, 0.0001, 0.2, true);
n=1    delta=0.70833
n=2    delta=0.14757
n=3    delta=0.11976
n=4    delta=0.048225
n=5    delta=0.023318
n=6    delta=0.0097561
n=7    delta=0.0043376
n=8    delta=0.0020174
n=9    delta=0.00098648
n=10    delta=0.00050221
n=11    delta=0.00024589
n=12    delta=9.1312e-05
>> stop_by
stop_by = 
    'epsilon'
>>  be{1}(1)
ans =
    0.4950
\end{verbatim} 
} \end{tcolorbox} 

Using verbose execution (6$^{th}$ argument of the function \courrier{gm\_infer\_GBP},
only 12 iterations are done for a quite good estimation of belief
(0.4950 instead of 0.4924). Note that damping do not often works so well.

So, giving the observations at time 3 (with only field 1 infected),
the probability of being infected at time 1
for field 1 is a little inferior at 0.5 (that is \emph{i.e.} unknown).

\end{document}
